
#include "base.as"

#library lMonoids         "Monoids.ao"
#library lSets               "Sets.ao"

import from lMonoids,lSets

+++
+++  Forgetful functor from Group to Set
+++
Group2Set(G:Groups):Set == G add
Group2Set(G:Groups,H:Groups,f:G->H):Group2Set G -> Group2Set H == f pretend (Group2Set G -> Group2Set H)

+++
+++  Free construction of a Group from a Set
+++
Set2Group(A:Set):Groups == add
    Rep == List Record(dom:A,inv:Boolean); import from Rep,SingleInteger
    (t:TextWriter)<<(x:%):TextWriter == 
        (w:TextWriter)**(r:Record(dom:A,inv:Boolean)):TextWriter == 
            r.inv => t << r.dom << "'"
            t << r.dom
        l:List Record(dom:A,inv:Boolean) == rep x
        empty? l => t
        for xx:Record(dom:A,inv:Boolean) in l repeat
            t := t ** xx
        t
    1:% == per [ ]
    inv(x:%):% ==  per [[((rep x).i).dom,~(((rep x).i).inv)] for i:SingleInteger in #(rep x)..1 by -1]
    (x:%)=(y:%):Boolean == 
        #(rep x)=#(rep y) => forall? ( (rep x).i = (rep y).i for i:SingleInteger in 1..#(rep x))
        false
    (x:%)*(y:%):% == 
        IRep == Record(dom:A,inv:Boolean); import from IRep
        xl:List IRep == rep x
        yl:List IRep == rep y
        cancel(a:IRep,b:IRep):Boolean == a.dom = b.dom and a.inv ~= b.inv
        mult(l:List IRep,r:List IRep):List IRep == 
            empty? l => r
            empty? r => l; S ==> SingleInteger; import from S
            if   cancel(last l,first r) then { mult([l.i for i:S in 1..(#l)-1],[r.i for i:S in 2..#r]) }
            else { concat(l,r) }
        per mult(xl,yl)
Set2Group(A:Set,B:Set,f:A->B)(a:Set2Group A):Set2Group B == 
   RepP == List Record(dom:A,inv:Boolean); import from RepP,SingleInteger
   import from List Record(dom:B,inv:Boolean)
   r:RepP == a pretend RepP
   [ [f ( (r.i).dom ), (r.i).inv ] for i:SingleInteger in 1..#r ] pretend Set2Group B
                   
+++
+++  Free construction adjoint
+++
FreeGroup:Adjoint(Set,Groups,Set2Group,Group2Set) == add
    <<(A:Set,B:Groups,f:A->Group2Set B):(Set2Group A->B) == 
        F(a:Set2Group A):B == 
            RepG == List Record(dom:A,inv:Boolean); import from RepG
            l:List B == [(f (x.dom)) pretend B for x in (a pretend RepG)]
            monoidProduct l
        F
    >>(A:Set,B:Groups,f:Set2Group A -> B):(A->Group2Set B) == 
        F(a:A):Group2Set B == 
            RepG == List Record(dom:A,inv:Boolean); import from RepG
            aa:Set2Group A == [a,true] pretend Set2Group A
            (f aa) pretend Group2Set B
        F
        
+++
+++  The Category of Groups
+++
GroupCategory:MathCategory Groups _
    with           Initial Groups _
    with             Final Groups _
    with           Product Groups _
    with         CoProduct Groups 
== add
---
---    In the category of groups, the trivial group {1} is both initial and final.
---
    One():Groups == 
        G0:Groups == (One()$MonoidCategory) add
            inv(x:%):% == x
        G0 add
    one(A:Groups):(A->One()) == (a:A):One() +-> 1$One()
    Zero():Groups == 
        G1:Groups == One() add
        G1 add
    zero(A:Groups):(Zero()->A) == (z:Zero()):A +-> 1$A
---
---    The Group Direct Product
---
    Product(A:Groups,B:Groups):(AB:Groups,AB->A,AB->B,(X:Groups)->(X->A,X->B)->(X->AB)) == 
        (P:Monoids,pa:P->A,pb:P->B,product:(X:Monoids)->(X->A,X->B)->(X->P)) == (Product$MonoidCategory)(A,B)
        extend P: with Groups == P add
            Rep == Record(a:A,b:B); import from Rep
            inv(x:%):% == per [ inv ((rep x).a), inv ( (rep x).b ) ]
        (P,pa,pb,product)
---
---    The sum of groups A and B is the free group on the disjoint union of G and H as Sets
---
    CoProduct(A:Groups,B:Groups):(AB:Groups,A->AB,B->AB,(X:Groups)->(A->X,B->X)->(AB->X)) == 
        (S:Set,ia:A->S,ib:B->S,coproduct) == (CoProduct$SetCategory)(A,B)
        import from FreeGroup
        SG:Groups == Set2Group A
        u:S->SG == unit(S) pretend (S->SG)
        coproduct2(X:Groups)(f:A->X,g:B->X):SG->X ==
            ff:S->Group2Set X == coproduct(X)(f,g) pretend (S->Group2Set X)
            (<<(S,X,ff)) pretend (SG->X)
        import from o(Set,A,S,SG),o(Set,B,S,SG)
        (SG,u**ia,u**ib,coproduct2)
