
#include "base.as"

#library lSets         "Sets.ao"
#library lDomains      "Domains.ao"

import from lSets,lDomains

+++
+++  The Dual functor
+++
Dual(A:Preorder):Preorder == 
    W2:Preorder == add
        Rep == A; import from Rep
        (t:TextWriter)<<(x:%):TextWriter == t << rep x
        (x:%)<=(y:%):Boolean == (rep y)<=(rep x)
    W2 add
Dual(A:Preorder,B:Preorder,f:A->B):Dual A->Dual B == f pretend (Dual A -> Dual B)

+++
+++  The interval functor
+++
Interval(P:Preorder):Preorder with { lo: % -> P; hi: % -> P } == 
    PF1:Preorder with { lo: % ->P; hi: % -> P } == add
        Rep == Record(a:P,b:P); import from Rep
        (t:TextWriter)<<(x:%):TextWriter == t << "( " << (rep x).a << ".." << (rep x).b << " )"
        (x:%)<=(y:%):Boolean == (rep x).a >= (rep y).a and (rep x).b <= (rep y).b
        lo(x:%):P == (rep x).a
        hi(x:%):P == (rep x).b
    PF1 add
Interval(A:Preorder,B:Preorder,f:A->B)(x:Interval A):Interval B == 
    RepA == Record(a:A,b:A); import from RepA
    RepB == Record(a:B,b:B); import from RepB
    [f ( (x pretend RepA).a ) , f ( (x pretend RepA).b ) ] pretend Interval B
    
+++
+++  The category of preorders
+++
PreorderCategory:MathCategory Preorder _
    with              Initial Preorder _
    with                Final Preorder _
    with              Product Preorder _
    with            CoProduct Preorder
== add 
    Zero():Preorder == 
        W0:Preorder == (Zero()$SetCategory) add
	    (x:%)<=(y:%):Boolean == never
        W0 add
    zero(A:Preorder):(Zero()->A) == (z:Zero()):A +-> never

    One():Preorder == 
        W1:Preorder == (One()$SetCategory) add
	    Rep == SingleInteger; import from Rep
	    (x:%)<=(y:%):Boolean == true
	W1 add
    one(A:Preorder):(A->One()) == (a:A):One() +-> (1$SingleInteger) pretend One() 

    Product(A:Preorder,B:Preorder):(AB:Preorder,AB->A,AB->B,(X:Preorder)->(X->A,X->B)->(X->AB)) == 
        (P:Set,pa:P->A,pb:P->B,product:(X:Set)->(X->A,X->B)->(X->P)) == (Product$SetCategory)(A,B)
	extend P: with Preorder == P add
	    import from A,B
	    (x:%)<=(y:%):Boolean == pa x <= pa y and pb x <= pb y
	(P,pa,pb,product)	

    CoProduct(A:Preorder,B:Preorder):(AB:Preorder,A->AB,B->AB,(X:Preorder)->(A->X,B->X)->(AB->X)) == 
        (S:Set,ia:A->S,ib:B->S,coproduct:(X:Domain)->(A->X,B->X)->(S->X)) == (CoProduct$SetCategory)(A,B)
        extend S: with Preorder == S add
            import from A,B
            Rep == Union(a:A,b:B); import from Rep
            (x:%)<=(y:%):Boolean == 
                (rep x) case a and (rep y) case a => (rep x).a <= (rep y).a
                (rep x) case a and (rep y) case b => false
                (rep x) case b and (rep y) case a => false
                (rep x) case b and (rep y) case b => (rep x).b <= (rep y).b
                never
        (S,ia,ib,coproduct)
        
